/* Problem URL: https://codeforces.com/gym/105900/problem/E */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

ll mod = 1e9 + 7;
int s = 27;

vvl operator*(vvl &a, vvl &b)
{
    vvl ans(s, vl(s));

    rep(i, s) {
        rep(j, s) {
            rep(k, s) {
                ans[i][j] = (ans[i][j] + a[i][k] * b[k][j]) % mod;
            }
        }
    }

    return ans;
}

vvl exponential(ll n)
{
    vvl ans(s, vl(s));
    rep(i, s) {
        ans[i][i] = 1;
    }

    vvl expc(s, vl(s));
    // expc[0][0] = 1;
    nrep(i, 1, s) {
        expc[i][i] = i;
        expc[i][i - 1] = 1;
    }

    rep(i, 60) {
        if ((n >> i) & 1) {
            ans = ans * expc;
        }

        expc = expc * expc;
    }

    return ans;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n;
    cin >> n;

    // vl trans(26);
    // trans[0] = 1;
    // nrep(i, 1, n) {
    //     for (int j = 25; j > 0; j--) {
    //         trans[j] = trans[j] * (j + 1) + trans[j - 1];
    //         trans[j] %= mod;
    //     }
    // }
    //
    // ll total = 0;
    // repv(i, trans) {
    //     total += i;
    //     total %= mod;
    // }
    //
    vvl ans = exponential(n);
    ll total = 0;

    rep(i, s) {
        total += ans[i][0];
        total %= mod;
    }

    cout << total << '\n';
}
